

####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was LunchboxConfig.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

####################################################################################

set(Lunchbox_PREFIX_DIR ${PACKAGE_PREFIX_DIR})
if(CMAKE_VERSION VERSION_LESS 2.8.3) # WAR bug
  get_filename_component(CMAKE_CURRENT_LIST_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
endif()
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})
# Copyright (c) 2014 Stefan.Eilemann@epfl.ch

# Provides common_package(Name args) which improves find_package.
# First invokes find_package with all the given arguments, and then
# falls back to using pkg_config if available. The pkg_config path
# does only implement the version, REQUIRED and QUIET find_package
# arguments (e.g. no COMPONENTS)

find_package(PkgConfig)
set(ENV{PKG_CONFIG_PATH}
  "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}")

macro(COMMON_PACKAGE Name)
  string(TOUPPER ${Name} COMMON_PACKAGE_NAME)
  set(COMMON_PACKAGE_ARGS ${ARGN}) # ARGN is not a list. make one.
  set(COMMON_PACKAGE_VERSION)

  if(COMMON_PACKAGE_ARGS)
    list(GET COMMON_PACKAGE_ARGS 0 COMMON_PACKAGE_VERSION)
    if(COMMON_PACKAGE_VERSION MATCHES "^[0-9.]+$") # is a version
      set(COMMON_PACKAGE_VERSION ">=${COMMON_PACKAGE_VERSION}")
    else()
      set(COMMON_PACKAGE_VERSION)
    endif()
  endif()

  list(FIND COMMON_PACKAGE_ARGS "QUIET" COMMON_PACKAGE_QUIET_POS)
  if(COMMON_PACKAGE_QUIET_POS EQUAL -1)
    set(COMMON_PACKAGE_QUIET)
  else()
    set(COMMON_PACKAGE_QUIET "QUIET")
  endif()

  list(FIND COMMON_PACKAGE_ARGS "REQUIRED" COMMON_PACKAGE_REQUIRED_POS)
  if(COMMON_PACKAGE_REQUIRED_POS EQUAL -1) # Optional find
    find_package(${Name} ${COMMON_PACKAGE_ARGS}) # try standard cmake way
    if((NOT ${Name}_FOUND) AND (NOT ${COMMON_PACKAGE_NAME}_FOUND) AND PKG_CONFIG_EXECUTABLE)
      pkg_check_modules(${Name} ${Name}${COMMON_PACKAGE_VERSION}
        ${COMMON_PACKAGE_QUIET}) # try pkg_config way
    endif()
  else() # required find
    list(REMOVE_AT COMMON_PACKAGE_ARGS ${COMMON_PACKAGE_REQUIRED_POS})
    find_package(${Name} ${COMMON_PACKAGE_ARGS}) # try standard cmake way
    if((NOT ${Name}_FOUND) AND (NOT ${COMMON_PACKAGE_NAME}_FOUND) AND PKG_CONFIG_EXECUTABLE)
      pkg_check_modules(${Name} REQUIRED ${Name}${COMMON_PACKAGE_VERSION}
        ${COMMON_PACKAGE_QUIET}) # try pkg_config way (and fail if needed)
    endif()
  endif()
endmacro()

set(_req)
set(_quiet)
set(Lunchbox_fail)
set(LUNCHBOX_COMPONENTS)
if(NOT LUNCHBOX_FOUND)
  set(LUNCHBOX_STATUS ON)
else()
  set(LUNCHBOX_STATUS)
endif()

if(Lunchbox_FIND_REQUIRED)
  set(_req REQUIRED)
endif()
if(Lunchbox_FIND_QUIETLY)
  set(_quiet QUIET)
endif()

set(_Boost_libraries_backup ${Boost_LIBRARIES})
set(_Boost_found_backup ${Boost_FOUND})
set(Boost_LIBRARIES)
set(Boost_FOUND)
common_package(Boost 1.66 QUIET ${_req} COMPONENTS regex serialization filesystem system thread)
if(Boost_FOUND)
  set(LUNCHBOX_Boost_LIBRARIES ${Boost_LIBRARIES})
  set(LUNCHBOX_Boost_FOUND TRUE)
  if("${Boost_VERSION}" MATCHES "^([0-9]+\\.[0-9]+)")
    if(NOT CMAKE_MATCH_1 VERSION_EQUAL 1.66)
      message(FATAL_ERROR "Boost ${CMAKE_MATCH_1} does not match expected version 1.66")
    endif()
  endif()
  list(APPEND LUNCHBOX_DEP_LIBRARIES ${Boost_LIBRARIES})
  list(APPEND LUNCHBOX_INCLUDE_DIRS ${Boost_INCLUDE_DIRS})
else()
  set(Lunchbox_fail "Boost ")
endif()
set(Boost_LIBRARIES ${_Boost_libraries_backup})
set(Boost_FOUND ${_Boost_found_backup})

set(LUNCHBOX_FIND_FILES )
set(_output_type)
set(_out)
if(Lunchbox_FIND_REQUIRED)
  set(_output_type FATAL_ERROR)
  set(_out 1)
else()
  set(_output_type STATUS)
  if(NOT Lunchbox_FIND_QUIETLY)
    set(_out 1)
  endif()
endif()
if(NOT Lunchbox_fail)
  list(APPEND LUNCHBOX_INCLUDE_DIRS ${Lunchbox_PREFIX_DIR}/include)
  set(LUNCHBOX_DEB_DEPENDENCIES "lunchbox3 (>= 1.10)")
  set(LUNCHBOX_DEB_LIB_DEPENDENCY "lunchbox3-lib (>= 1.10)")
  set(LUNCHBOX_DEB_DEV_DEPENDENCY "lunchbox3-dev (>= 1.10)")

  if(Lunchbox_FIND_COMPONENTS)
    find_library(${UPPER_PROJECT_NAME}_LIBRARY Lunchbox NO_DEFAULT_PATH
                 PATHS ${Lunchbox_PREFIX_DIR} PATH_SUFFIXES lib )
    list(APPEND LUNCHBOX_LIBRARIES ${LUNCHBOX_LIBRARY})
    foreach(_component ${Lunchbox_FIND_COMPONENTS})
      find_library(${_component}_libraryname Lunchbox_${_component} NO_DEFAULT_PATH
        PATHS ${Lunchbox_PREFIX_DIR} PATH_SUFFIXES lib )

      if(${_component}_libraryname MATCHES "${_component}_libraryname-NOTFOUND")
        if(Lunchbox_FIND_REQUIRED_${_component})
          set(Lunchbox_fail "Component ${_component} ")
          message(FATAL_ERROR "   Lunchbox_${_component} "
            "not found in ${Lunchbox_PREFIX_DIR}/lib")
        elseif(NOT _quiet)
          message(STATUS "   Lunchbox_${_component} "
            "not found in ${Lunchbox_PREFIX_DIR}/lib")
        endif()
      else()
        string(TOUPPER ${_component} _COMPONENT)
        set(LUNCHBOX_${_COMPONENT}_FOUND TRUE)
        set(LUNCHBOX_${_COMPONENT}_LIBRARY ${${_component}_libraryname})
        list(APPEND LUNCHBOX_LIBRARIES ${${_component}_libraryname})
        list(APPEND LUNCHBOX_COMPONENTS ${_component})
      endif()
    endforeach()
  elseif(LUNCHBOX_FIND_FILES)
    find_file(LUNCHBOX_FILE NAMES  NO_DEFAULT_PATH
              PATHS ${Lunchbox_PREFIX_DIR} PATH_SUFFIXES include)
    if(LUNCHBOX_FILE MATCHES "LUNCHBOX_FILE-NOTFOUND")
      set(Lunchbox_fail " ")
      if(_out)
        message(${_output_type} "   Missing the Lunchbox "
          "file in ${Lunchbox_PREFIX_DIR}/include.")
      endif()
    endif()
  else()
    set(LUNCHBOX_LIBRARY_NAMES "Lunchbox")
    foreach(_libraryname ${LUNCHBOX_LIBRARY_NAMES})
      string(TOUPPER ${_libraryname} _LIBRARYNAME)
      find_library(${_LIBRARYNAME}_LIBRARY ${_libraryname} NO_DEFAULT_PATH
                   PATHS ${Lunchbox_PREFIX_DIR} PATH_SUFFIXES lib )
      if(${_LIBRARYNAME}_LIBRARY MATCHES "${_LIBRARYNAME}_LIBRARY-NOTFOUND")
        set(Lunchbox_fail "${_libraryname} ")
        if(_out)
          message(${_output_type}
            "   Missing ${_libraryname} in ${Lunchbox_PREFIX_DIR}/lib")
        endif()
      else()
        list(APPEND LUNCHBOX_LIBRARIES ${${_LIBRARYNAME}_LIBRARY})
        string(REPLACE "Lunchbox_" "" _component ${_libraryname})
        string(TOUPPER ${_component} _COMPONENT)
        set(LUNCHBOX_${_COMPONENT}_FOUND TRUE)
        list(APPEND LUNCHBOX_COMPONENTS ${_component})
      endif()
    endforeach()
  endif()

  if(EXISTS ${Lunchbox_PREFIX_DIR}/share/Lunchbox/CMake/options.cmake)
    include(${Lunchbox_PREFIX_DIR}/share/Lunchbox/CMake/options.cmake)
  endif()
endif()

list(APPEND LUNCHBOX_LIBRARIES ${LUNCHBOX_DEP_LIBRARIES})
set(LUNCHBOX_DEP_LIBRARIES)
if(Lunchbox_fail)
  set(LUNCHBOX_FOUND)
  set(Lunchbox_FOUND)
  set(LUNCHBOX_VERSION)
  set(LUNCHBOX_VERSION_ABI)
  set(LUNCHBOX_INCLUDE_DIRS)
  set(LUNCHBOX_LIBRARIES)
  set(LUNCHBOX_DEB_DEPENDENCIES)
  set(LUNCHBOX_LIBRARY)
  set(LUNCHBOX_COMPONENTS)
  if(_out)
    message(STATUS "Could not find Lunchbox: ${Lunchbox_fail} not found")
  endif()
else()
  set(LUNCHBOX_FOUND TRUE)
  set(Lunchbox_FOUND TRUE)
  set(LUNCHBOX_VERSION 1.10.0)
  set(LUNCHBOX_VERSION_ABI 3)
  set(LUNCHBOX_MODULE_FILENAME )
  list(SORT LUNCHBOX_INCLUDE_DIRS)
  list(REMOVE_DUPLICATES LUNCHBOX_INCLUDE_DIRS)
  if(LUNCHBOX_LIBRARIES)
    list(REMOVE_DUPLICATES LUNCHBOX_LIBRARIES)
  endif()
  if(_out AND LUNCHBOX_STATUS)
    message(STATUS "Found Lunchbox 1.10.0-3 [${LUNCHBOX_COMPONENTS}] in "
      "${LUNCHBOX_INCLUDE_DIRS}:${LUNCHBOX_LIBRARY}")
  endif()
endif()
